//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2000
//  A Comparator class for the Client class

package schaums.dswj;

public class ClientComparator implements java.util.Comparator
{ public int compare(Object o1, Object o2)
  { if (o1==null || !(o1 instanceof Client)) return -1;
    Client c1 = (Client)o1;
    if (o2==null || !(o2 instanceof Client)) return  1;
    Client c2 = (Client)o2;
    if (c1.getJobSize()<c2.getJobSize()) return -1;
    if (c1.getJobSize()>c2.getJobSize()) return  1;
    return 0;
  }
}