//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Problem 7.2 on page 138
//  Testing a reverse(ArrayQueue) method

import java.util.Stack;

public class Pr0702
{ public static void main(String[] args)
  { ArrayQueue kids = new ArrayQueue();
    kids.enqueue("Sara");
    kids.enqueue("John");
    kids.enqueue("Andy");
    kids.enqueue("Mike");
    System.out.println(kids);
    reverse(kids);
    System.out.println(kids);
  }
  
  private static void reverse(ArrayQueue queue)
  { Stack tempStack = new Stack();
    while(!queue.isEmpty())
      tempStack.push(queue.dequeue());
    while(!tempStack.empty())
      queue.enqueue(tempStack.pop());
  }
}
