//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Problem 7.3 on page 139

import java.util.Stack;

public class Pr0703
{ public static void main(String[] args)
  { ArrayQueue kids = new ArrayQueue();
    kids.enqueue("Sara");
    kids.enqueue("John");
    kids.enqueue("Andy");
    kids.enqueue("Mike");
    System.out.println(kids);
    System.out.println(reversed(kids));
  }
  
  private static ArrayQueue reversed(ArrayQueue queue)
  { ArrayQueue newQueue = new ArrayQueue();
    Stack stack = new Stack();
    while(!queue.isEmpty())
    { Object x = queue.dequeue();
      stack.push(x);
      newQueue.enqueue(x);
    }
    while(!newQueue.isEmpty())
      queue.enqueue(newQueue.dequeue());
    while(!stack.empty())
      newQueue.enqueue(stack.pop());
    return newQueue;
  }
}
