//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Problem 7.7 on page 140

public class Pr0707
{ public static void main(String[] args)
  { ArrayQueue ours = new ArrayQueue();
    ours.enqueue("Sara");
    ours.enqueue("John");
    ours.enqueue("Andy");
    ours.enqueue("Mike");
    System.out.println(ours);
    ArrayQueue theirs = new ArrayQueue();
    theirs.enqueue("Bill");
    theirs.enqueue("Tom");
    theirs.enqueue("Jim");
    theirs.enqueue("Greg");
    System.out.println(theirs);
    ArrayQueue kids = merged(theirs,ours);
    System.out.println(ours);
    System.out.println(theirs);
    System.out.println(kids);
  }
  
  public static ArrayQueue merged(ArrayQueue q1, ArrayQueue q2)
  { ArrayQueue newQueue = new ArrayQueue();
    while(!q1.isEmpty() && !q2.isEmpty())
    { newQueue.enqueue(q1.dequeue());
      newQueue.enqueue(q2.dequeue());
    }
    while(!q1.isEmpty())
      newQueue.enqueue(q1.dequeue());
    while(!q2.isEmpty())
      newQueue.enqueue(q2.dequeue());
    return newQueue;
  }
}
